{
	WGPCMDAT - Un programma per trasmettere via packet i tempi dei rally
	Copyright (C) 2008 Sezione ARI Casale Monferrato & I1EPJ

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}
unit Uterm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Menus;

type
  TTerm = class(TForm)
    Terminale: TMemo;
    MainMenu1: TMainMenu;
    Cancella1: TMenuItem;
    Salva1: TMenuItem;
    SaveTerm: TSaveDialog;
    Esci1: TMenuItem;
    procedure TerminaleKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure Cancella1Click(Sender: TObject);
    procedure Salva1Click(Sender: TObject);
    procedure Esci1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Term: TTerm;

implementation

uses Wgpcmu1;

{$R *.DFM}

procedure TTerm.TerminaleKeyPress(Sender: TObject; var Key: Char);

var s: string;

begin
	if Key=CR then begin
        	s := Terminale.Lines[Terminale.Lines.Count-1]+chr(13);
                if s='cmd:'+CR then s:=CR;
        	MainForm.RS232.SendString(s);
                MainForm.ScriviLog(s,FALSE);
        end;
        if Key=CTRLC then begin
        	s := CTRLC;
        	if MainForm.RS232.SendString(s) then begin
                	MainForm.ScriviTerminale(s);
                        MainForm.ScriviLog(s,FALSE);
                end;
        end;
        if Key=CTRLA then begin
        	s := CTRLA;
        	if MainForm.RS232.SendString(s) then begin
                	MainForm.ScriviTerminale(s);
                        MainForm.ScriviLog(s,FALSE);
                end;
        end;
end;

procedure TTerm.FormCreate(Sender: TObject);
begin
	if MainForm.InizializzaRS232 then begin
        	if Config.InizializzaTNC then
                	MainForm.InizializzaTNC
                else
                	MainForm.MostraMessaggio(
                        	'Inizializzazione TNC disabilitata',
                                'Attenzione!');
        end;
end;

procedure TTerm.Cancella1Click(Sender: TObject);
begin
	Terminale.Lines.Clear;
end;

procedure TTerm.Salva1Click(Sender: TObject);

begin
	SaveTerm.InitialDir := Config.MsgDir;
        if SaveTerm.Execute then Terminale.Lines.SaveToFile(SaveTerm.Filename);
end;

procedure TTerm.Esci1Click(Sender: TObject);
begin
	Hide;
end;

end.
