{
	WGPCMDAT - Un programma per trasmettere via packet i tempi dei rally
	Copyright (C) 2008 Sezione ARI Casale Monferrato & I1EPJ

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit Wgpcmu1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Menus, Grids, StdCtrls, Buttons, Mask, UTerm, About,
  ExtCtrls,GNULic,UConfPrg,UConfSer, Uerr, UlogV, ComDrv16;

const
  VERSIONE = 'WGPCMDAT 1.0';

  NUL = chr(0);
  CR = chr(13);
  LF = chr(10);
  CTRLA = chr(1);
  CTRLC = chr(3);

  NOERROR= 0;
  NODATA = 1;
  TWTNUM = 2;
  NWTTIM = 3;
  CHG255 = 4;
  NUMDUP = 5;
  MING59 = 6;
  SECG59 = 7;

  TncCmds: array[1..18] of string =
        ('ECHO OFF'+CR,
	'SENDPAC $01'+CR,
	'MONITOR OFF'+CR,
	'AUTOLF OFF'+CR,
	'PACLEN 255'+CR,
	'MAXFRAME 4'+CR,
	'PERSIST 248'+CR,
	'TXDELAY 40'+CR,
	'USERS 1'+CR,
	'FLOW OFF'+CR,
	'XFLOW ON'+CR,
	'AWLEN 8'+CR,
	'PARITY 0'+CR,
	'DAYUSA OFF'+CR,
	'CR ON'+CR,
	'STREAMSW $7C'+CR,
	'CONMODE CONVERSE'+CR,
	'RESTART'+CR); { deve essere l'ultimo comando }

  NUMCMDS = 18;

  Errori: array[1..7] of string =
        ('Non ci sono tempi',
         'Tempo o commento senza numero',
         'Tempo mancante o incompleto',
         'Numero caratteri > 255',
  	 'Numero concorrente ripetuto',
         'Minuti > 59',
         'Secondi > 59');

  SECONDI = 0;
  DECIMI = 1;
  CENTESIMI = 2;

  NORMALE = 0;
  EDITING = 1;

  COM1 = 0;
  COM2 = 1;
  COM3 = 2;
  COM4 = 3;

  BIT7 = 0;
  BIT8 = 1;

  B1200  = 0;
  B2400  = 1;
  B4800  = 2;
  B9600  = 3;
  B19200 = 4;
  B38400 = 5;
  B57600 = 6;
  B115200= 7;

  STOP1 = 0;
  STOP2 = 1;

  PNONE = 0;
  PODD = 1;
  PEVEN = 2;

  HNONE = 0;
  HHARDWARE = 1;
  HSOFTWARE = 2;

type
  TMainForm = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Configurazione1: TMenuItem;
    Informazionisu1: TMenuItem;
    Programma1: TMenuItem;
    Portaseriale1: TMenuItem;
    N1: TMaskEdit;
    N2: TMaskEdit;
    N3: TMaskEdit;
    N4: TMaskEdit;
    N5: TMaskEdit;
    CL1: TMaskEdit;
    CL2: TMaskEdit;
    TM1: TMaskEdit;
    TM2: TMaskEdit;
    TM3: TMaskEdit;
    TM4: TMaskEdit;
    TM5: TMaskEdit;
    TS1: TMaskEdit;
    TS2: TMaskEdit;
    TS3: TMaskEdit;
    TS4: TMaskEdit;
    TS5: TMaskEdit;
    TD1: TMaskEdit;
    TD2: TMaskEdit;
    TD3: TMaskEdit;
    TD4: TMaskEdit;
    TD5: TMaskEdit;
    C5: TMaskEdit;
    C4: TMaskEdit;
    C3: TMaskEdit;
    C2: TMaskEdit;
    C1: TMaskEdit;
    Informazionisu2: TMenuItem;
    Esci1: TMenuItem;
    Terminale1: TMenuItem;
    Visualizza1: TMenuItem;
    Nascondi1: TMenuItem;
    Label4: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    NCAR: TLabel;
    SalvaTX: TButton;
    Button1: TButton;
    Annulla: TButton;
    Label1: TLabel;
    Label9: TLabel;
    Connessione1: TMenuItem;
    ConnettiDirezioneGara1: TMenuItem;
    DisconnettiDirezioneGara1: TMenuItem;
    Ora: TLabel;
    Timer1: TTimer;
    GNUPublicLicense1: TMenuItem;
    Caricafoglio1: TMenuItem;
    N6: TMenuItem;
    OpenDialog1: TOpenDialog;
    TX: TButton;
    Ritrasmettifoglio1: TMenuItem;
    RS232: TCommPortDriver;
    Timeout: TTimer;
    N7: TMenuItem;
    InizializzaTNC1: TMenuItem;
    N8: TMenuItem;
    Mostralog1: TMenuItem;
    NPS: TMaskEdit;
    NFG: TMaskEdit;
    procedure FormCreate(Sender: TObject);
    procedure LeggiConfig;
    procedure SalvaConfig;
    procedure MakeCaption;
    procedure ComError;
    function InizializzaRS232: boolean;
    procedure InizializzaTNC;
    procedure Parse(Line: string);
    procedure ScriviLog(Line: string; RX: boolean);
    procedure ScriviTerminale(Line: string);
    procedure MaskEditKeyPress(Sender: TObject; var Key: Char);
    procedure SalvaTXKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SalvaTXClick(Sender: TObject);
    procedure CancellaFoglio;
    procedure NuovoFoglio;
    procedure SalvaClick(Sender: TObject);
    procedure AnnullaClick(Sender: TObject);
    procedure Visualizza1Click(Sender: TObject);
    procedure Nascondi1Click(Sender: TObject);
    procedure Esci1Click(Sender: TObject);
    procedure Informazionisu2Click(Sender: TObject);
    procedure InizializzaMsg;
    procedure AggiornaNcar;
    procedure CompilaMsg;
    procedure TrasmettiMsg;
    procedure SalvaMsg;
    function MsgOK: integer;
    function Trim(st: string): string;
    procedure FormResize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure GNUPublicLicense1Click(Sender: TObject);
    procedure Caricafoglio1Click(Sender: TObject);
    procedure Ritrasmettifoglio1Click(Sender: TObject);
    procedure Programma1Click(Sender: TObject);
    procedure Portaseriale1Click(Sender: TObject);
    procedure TXClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RS232ReceiveData(Sender: TObject; DataPtr: Pointer;
      DataSize: Integer);
    procedure TimeoutTimer(Sender: TObject);
    procedure ConnettiDirezioneGara1Click(Sender: TObject);
    procedure DisconnettiDirezioneGara1Click(Sender: TObject);
    procedure MostraMessaggio(Testo,Titolo: pChar);
    procedure MostraErrore(ErrCode: integer);
    procedure InizializzaTNC1Click(Sender: TObject);
    procedure Mostralog1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TConfig = record
  	NomeRally : string;
        MsgDir: string;
        PSNum: integer;
        FGNum: integer;
        SecDecCent: integer;
        CallStazione: string;
        CallDirGara: string;
        Digi1: string;
        Digi2: string;
        Connesso: boolean;
        LogToFile: boolean;
        ComPort: integer;
        ComBaud: integer;
        ComBits: integer;
        ComParity: integer;
        ComStops: integer;
        ComHandshake: integer;
        InizializzaTNC: boolean;
  end;


var
  MainForm: TMainForm;
  Config: TConfig;
  Primo: boolean;
  Stato: integer;
  nc: integer;
  Msg: array[1..11] of string;
  Xs: array[1..60] of Longint;
  Ys: array[1..60] of Longint;
  Ws: array[1..60] of Longint;
  Hs: array[1..60] of Longint;
  OH, OW: Longint;
  PrevHeight, PrevWidth: longint;
  hOldFont,hNewFont: hFont;
  sBuf: string;
  Line: string;
  LogF: TextFile;
  LogFileName: string;
  NominativoConnesso: string;
implementation

{$R *.DFM}

{====================
 Procedure e funzioni
 ====================}

procedure TMainForm.ScriviTerminale(Line: string);

begin
	if Term.Terminale.Lines.Count>=1000 then begin
		Term.Terminale.Lines.Delete(0);
        end;
       	Term.Terminale.Lines.Add(Line);
end;


procedure TMainForm.ScriviLog(Line: string; RX: boolean);

var i: integer;

begin
	if Config.LogToFile then begin
                if RX then write(LogF,'RX:') else write(LogF,'TX:');
                repeat
                	i:=pos(CR,Line);
                	if i<>0 then Line[i]:='';
                until i=0;
		repeat
                	i:=pos(CTRLA,Line);
                	if i<>0 then Line[i]:='@';
                until i=0;
                repeat
                	i:=pos(CTRLC,Line);
                	if i<>0 then Line[i]:='';
                until i=0;
        	WriteLn(LogF,''+Line+'');
                Flush(LogF);
        end;
end;


procedure TMainForm.MostraErrore(ErrCode: integer);

begin
        MessageBeep(MB_ICONASTERISK);
        Ferr.Caption := 'Qualcosa non va...';
        FErr.LErr.Caption := Errori[ErrCode];
	Ferr.ShowModal;
end;

procedure TMainForm.MostraMessaggio(Testo,Titolo: pChar);

begin
        MessageBeep(MB_ICONEXCLAMATION);
        Ferr.Caption := StrPas(Titolo);
        FErr.LErr.Caption := StrPas(Testo);
	Ferr.ShowModal;
end;


function TMainForm.InizializzaRS232: Boolean;

var
	s: string;
	sz: PChar;

begin
	RS232.Disconnect;

	case Config.ComPort of
        	0: RS232.ComPort := pnCOM1;
        	1: RS232.ComPort := pnCOM2;
        	2: RS232.ComPort := pnCOM3;
        	3: RS232.ComPort := pnCOM4;
        end;

        case Config.ComBaud of
        	0: RS232.ComPortSpeed := br1200;
        	1: RS232.ComPortSpeed := br2400;
        	2: RS232.ComPortSpeed := br4800;
        	3: RS232.ComPortSpeed := br9600;
        	4: RS232.ComPortSpeed := br19200;
        	5: RS232.ComPortSpeed := br38400;
        	6: RS232.ComPortSpeed := br57600;
        	7: RS232.ComPortSpeed := br115200;
        end;

        case Config.ComBits of
        	0: RS232.ComPortDataBits := db7BITS;
                1: RS232.ComPortDataBits := db8BITS;
        end;

        case Config.ComParity of
        	0: RS232.ComPortParity := ptNONE;
                1: RS232.ComPortParity := ptODD;
        	2: RS232.ComPortParity := ptEVEN;
        end;

        case Config.ComStops of
        	0: RS232.ComPortStopBits := sb1BITS;
                1: RS232.ComPortStopBits := sb2BITS;
        end;

        case Config.ComHandshake of
        	0: begin
                	RS232.ComPortHwHandshaking := hhNONE;
			RS232.ComPortSwHandshaking := shNONE;
                end;
                1: begin
                	RS232.ComPortHwHandshaking := hhRTSCTS;
			RS232.ComPortSwHandshaking := shNONE;
                end;
                2: begin
                	RS232.ComPortHwHandshaking := hhNONE;
			RS232.ComPortSwHandshaking := shXONXOFF;
                end;
        end;

        InizializzaRS232 := TRUE;
       	if not RS232.Connect then begin
        	SZ := StrAlloc(256);
                FmtStr(s,'Non riesco ad aprire COM%s',[IntToStr(Config.COMPort+1)]);
                StrPCopy(sz,s);
        	MostraMessaggio(sz, 'Errore RS232');
                InizializzaRS232 := FALSE;
                StrDispose(sz);
        end;
        RS232.FlushBuffers(TRUE,TRUE);

end;


procedure TMainForm.ComError;

begin
	MostraMessaggio('Invio dati fallito','Errore RS232');
end;


procedure TMainForm.InizializzaTNC;

var s:string;
    n: integer;
    t: TDateTime;

begin
	s := chr(192)+chr(255)+chr(192);
       	if RS232.SendString(s) then begin
        	ScriviTerminale(s);
		ScriviLog(s,FALSE);
	end;

        t := Time;
       	while (Time-t)<1/86400 do;
        s := CTRLC+CTRLC+CTRLC;
       	if RS232.SendString(s) then begin
        	ScriviTerminale(s);
                ScriviLog(s,FALSE);
        end;
        t := Time;
       	while (Time-t)<1/86400 do;

        s := CR;
        if RS232.SendString(s) then begin
        	ScriviTerminale(s);
                ScriviLog(s,FALSE);
        end;
       	s:='MYCALL '+Config.CallStazione+CR;
       	if RS232.SendString(s) then begin
       		ScriviTerminale(s);
                ScriviLog(s,FALSE);
       	end else begin
       		ComError;
       		exit;
	end;
	for n:=1 to NUMCMDS do begin
       		if RS232.SendString(TNCCmds[n]) then begin
               		ScriviTerminale(TNCCmds[n]);
                        ScriviLog(TNCCmds[n],FALSE);
                end else begin
       	               	 ComError;
               	         Break;
                end;
       	end;
end;


procedure TMainForm.LeggiConfig;

var
	f: file of TConfig;

begin
	AssignFile(f,'wgpcmdat.cnf');
        try
        	reset(f);
                read(f,Config);
        	CloseFile(f);
                Config.Connesso := FALSE;
        except
        	{ Configurazione inesistente, salva quella di default }
                rewrite(f);
                write(f,Config);
                CloseFile(f);
        end;
end;


procedure TMainForm.SalvaConfig;

var
	f: file of TConfig;

begin
	AssignFile(f,'wgpcmdat.cnf');
        try
        	rewrite(f);
                write(f,Config);
        	CloseFile(f);
        except
        end;
end;


procedure TMainForm.InizializzaMsg;

var n: integer;

begin
        for n:=1 to 11 do Msg[n] := '';
end;


function TMainForm.Trim(st: string): string;

var n,i: integer;

begin
        sBuf:='';
	for n:=1 to Length(st) do
        	if st[n]<>' ' then begin
                	AppendStr(sBuf,st[n]);
                	i := i+1;
                end;
        Trim := sBuf;
end;


procedure TMainForm.CompilaMsg;

var
	NumTempi: integer;
begin
	InizializzaMsg;
        Msg[1] := '$T'+CR;
        NumTempi := 0;
        if Stato=NORMALE then
        	Msg[2] := 'PS '+IntToStr(Config.PSNum)+' F '+IntToStr(Config.FGNum)+CR
        else
        	Msg[2] := 'PS '+NPS.Text+' F '+NFG.Text+CR;
        case Config.SecDecCent of
        	SECONDI: begin
        		if N1.Text <> '' then begin
                        	Msg[3] := Trim(N1.Text)+' '+Trim(TM1.Text)+' '+Trim(TS1.Text);
                                NumTempi := NumTempi+1;
                        end;
                        if C1.Text <> '' then Msg[3] := Msg[3]+' '+C1.Text;
                        AppendStr(Msg[3],CR);
        		if N2.Text <> '' then begin
                        	Msg[4] := Trim(N2.Text)+' '+Trim(TM2.Text)+' '+Trim(TS2.Text);
                                NumTempi := NumTempi+1;
                        end;
                        if C2.Text <> '' then Msg[4] := Msg[4]+' '+C2.Text;
                        AppendStr(Msg[4],CR);
        		if N3.Text <> '' then begin
                        	Msg[5] := Trim(N3.Text)+' '+Trim(TM3.Text)+' '+Trim(TS3.Text);
                                NumTempi := NumTempi+1;
                        end;
                        if C3.Text <> '' then Msg[5] := Msg[5]+' '+C3.Text;
                        AppendStr(Msg[5],CR);
                        if N4.Text <> '' then begin
                        	Msg[6] := Trim(N4.Text)+' '+Trim(TM4.Text)+' '+Trim(TS4.Text);
				NumTempi := NumTempi+1;
                        end;
			if C4.Text <> '' then Msg[6] := Msg[6]+' '+C4.Text;
                        AppendStr(Msg[6],CR);
        		if N5.Text <> '' then begin
                        	Msg[7] := Trim(N5.Text)+' '+Trim(TM5.Text)+' '+Trim(TS5.Text);
                                NumTempi := NumTempi+1;
                        end;
                        if C5.Text <> '' then Msg[7] := Msg[7]+' '+C5.Text+CR;
                        AppendStr(Msg[7],CR);
                end;
                DECIMI,CENTESIMI: begin
        		if N1.Text <> '' then begin
                        	Msg[3] := Trim(N1.Text)+' '+Trim(TM1.Text)+' '+Trim(TS1.Text)+' '+Trim(TD1.Text);
                                NumTempi := NumTempi+1;
                        end;
                        if C1.Text <> '' then Msg[3] := Msg[3]+' '+C1.Text;
                        AppendStr(Msg[3],CR);
        		if N2.Text <> '' then begin
                        	Msg[4] := Trim(N2.Text)+' '+Trim(TM2.Text)+' '+Trim(TS2.Text)+' '+Trim(TD2.Text);
                                NumTempi := NumTempi+1;
                        end;
                        if C2.Text <> '' then Msg[4] := Msg[4]+' '+C2.Text;
                        AppendStr(Msg[4],CR);
        		if N3.Text <> '' then begin
                        	Msg[5] := Trim(N3.Text)+' '+Trim(TM3.Text)+' '+Trim(TS3.Text)+' '+Trim(TD3.Text);
                                NumTempi := NumTempi+1;
                        end;
                        if C3.Text <> '' then Msg[5] := Msg[5]+' '+C3.Text;
                        AppendStr(Msg[5],CR);
			if N4.Text <> '' then begin
                        	Msg[6] := Trim(N4.Text)+' '+Trim(TM4.Text)+' '+Trim(TS4.Text)+' '+Trim(TD4.Text);
                                NumTempi := NumTempi+1;
                        end;
                        if C4.Text <> '' then Msg[6] := Msg[6]+' '+C4.Text;
                        AppendStr(Msg[6],CR);
        		if N5.Text <> '' then begin
                        	Msg[7] := Trim(N5.Text)+' '+Trim(TM5.Text)+' '+Trim(TS5.Text)+' '+Trim(TD5.Text);
                                NumTempi := NumTempi+1;
                        end;
                        if C5.Text <> '' then Msg[7] := Msg[7]+' '+C5.Text;
                        AppendStr(Msg[7],CR);
                end;
        end;
        if (CL1.Text <> '') or (CL2.Text <> '') then begin
        	if NumTempi=5 then begin
	        	Msg[8] := CL1.Text+CR;
        	        Msg[9] := CL2.Text+CR;
                end else begin
                	Msg[8] := '$N'+CR;
	        	Msg[9] := CL1.Text+CR;
        	        Msg[10] := CL2.Text+CR;
                end
        end else begin
        	Msg[8] := '';
                Msg[9] := '';
                Msg[10] := ''
        end;
        Msg[11]:=CTRLA;
end;


procedure TMainForm.TrasmettiMsg;

var n: integer;

begin
       	for n := 1 to 11 do begin
               	if (Msg[n]<>'') and (Msg[n,1]<>CR) then begin
                	if RS232.SendString(Msg[n]) then begin
                        	ScriviTerminale(Msg[n]);
                                ScriviLog(Msg[n],FALSE);
                        end;
                end;
        end;
end;


procedure TMainForm.SalvaMsg;

var f: textfile;
    fn: string;
    n: integer;

begin
	if Stato=NORMALE then begin
		FmtStr(fn,'%s\PS%dF%d.FOG',[Config.MsgDir,Config.PSNum,Config.FGNum]);
        end else begin
		FmtStr(fn,'%s\PS%sF%s.FOG',[Config.MsgDir,NPS.Text,NFG.Text]);
        end;
        AssignFile(f,fn);
        Rewrite(f);
        CompilaMsg;
       	for n := 1 to 11 do Write(f,Msg[n]);
        CloseFile(f);
end;

{ Controlla la validit del messaggio }
function TMainForm.MsgOK: integer;

var
	temp: array[1..5] of integer;
        err,ris,nc,n: integer;

begin
	ris := 0;
        err:=0;
        nc := 0;

        { Verifica che il numero di caratteri non sia eccessivo }
	CompilaMsg;
        for n:=1 to 11 do nc := nc + length(Msg[n]);
        if nc>255 then begin
        	ris := CHG255;
                NCAR.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
	end;

        { Verifica che ci sia almeno un concorrente }
        if (N1.Text='') and (N2.Text='') and (N3.Text='') and (N4.Text='') and (N5.Text='') then begin
        	if (TM1.Text='') and (TM2.Text='') and (TM3.Text='') and (TM4.Text='') and (TM5.Text='') and
                   (TS1.Text='') and (TS2.Text='') and (TS3.Text='') and (TS4.Text='') and (TS5.Text='') and
                   (TD1.Text='') and (TD2.Text='') and (TD3.Text='') and (TD4.Text='') and (TD5.Text='') then begin
                	ris := NODATA;
                        MostraErrore(ris);
	                N1.SetFocus;
                end;
        end;

        { Verifica che non ci siano tempi senza concorrente }
        if (N1.Text='') then begin
        	if (TM1.Text<>'') or (TS1.Text<>'') or (TD1.Text<>'') or (C1.text<>'') then begin
                	ris := TWTNUM;
                        N1.Color := clRed;
	                MostraErrore(ris);
                        N1.Color := clAqua;
	                N1.SetFocus;
                end;
        end;

        if (N2.Text='') then begin
        	if (TM2.Text<>'') or (TS2.Text<>'') or (TD2.Text<>'') or (C2.text<>'') then begin
                	ris := TWTNUM;
                        N2.Color := clRed;
	                MostraErrore(ris);
                        N2.Color := clAqua;
	                N1.SetFocus;
                end;
        end;

        if (N3.Text='') then begin
        	if (TM3.Text<>'') or (TS3.Text<>'') or (TD3.Text<>'') or (C3.text<>'') then begin
                	ris := TWTNUM;
                        N3.Color := clRed;
	                MostraErrore(ris);
                        N3.Color := clAqua;
	                N1.SetFocus;
                end;
        end;

        if (N4.Text='') then begin
        	if (TM4.Text<>'') or (TS4.Text<>'') or (TD4.Text<>'') or (C4.text<>'') then begin
                	ris := TWTNUM;
                        N4.Color := clRed;
	                MostraErrore(ris);
                        N4.Color := clAqua;
	                N1.SetFocus;
                end;
        end;

        if (N5.Text='') then begin
        	if (TM5.Text<>'') or (TS5.Text<>'') or (TD5.Text<>'') or (C5.text<>'') then begin
                	ris := TWTNUM;
                        N5.Color := clRed;
	                MostraErrore(ris);
                        N5.Color := clAqua;
	                N1.SetFocus;
                end;
        end;

        { Verifica che non ci siano concorrenti senza tempo }
        if (TM1.Text='') or (TS1.Text='') or ((TD1.Text='') and (Config.SecDecCent<>SECONDI)) then begin
        	if N1.Text<>'' then begin
                	ris := NWTTIM;
                        N1.Color := clRed;
	                MostraErrore(ris);
                        N1.Color := clAqua;
	                N1.SetFocus;
                end;
        end;
        if (TM2.Text='') or (TS2.Text='') or ((TD2.Text='') and (Config.SecDecCent<>SECONDI)) then begin
        	if N2.Text<>'' then begin
                	ris := NWTTIM;
                        N2.Color := clRed;
	                MostraErrore(ris);
                        N2.Color := clAqua;
	                N1.SetFocus;
                end;
        end;
        if (TM3.Text='') or (TS3.Text='') or ((TD3.Text='') and (Config.SecDecCent<>SECONDI)) then begin
        	if N3.Text<>'' then begin
                	ris := NWTTIM;
                        N3.Color := clRed;
	                MostraErrore(ris);
                        N3.Color := clAqua;
	                N1.SetFocus;
                end;
        end;
        if (TM4.Text='') or (TS4.Text='') or ((TD4.Text='') and (Config.SecDecCent<>SECONDI)) then begin
        	if N4.Text<>'' then begin
                	ris := NWTTIM;
                        N4.Color := clRed;
	                MostraErrore(ris);
                        N4.Color := clAqua;
	                N1.SetFocus;
                end;
        end;
        if (TM5.Text='') or (TS5.Text='') or ((TD5.Text='') and (Config.SecDecCent<>SECONDI)) then begin
        	if N5.Text<>'' then begin
                	ris := NWTTIM;
                        N5.Color := clRed;
	                MostraErrore(ris);
                        N5.Color := clAqua;
	                N1.SetFocus;
                end;
        end;

        { Verifica che non ci siano numeri ripetuti }
        if N1.Text<>'' then
        	val(N1.Text,temp[1],err)
        else
        	temp[1]:= -1111;
        if N2.Text<>'' then
        	val(N2.Text,temp[2],err)
        else
        	temp[2] := -2222;
        if N3.Text<>'' then
                val(N3.Text,temp[3],err)
        else
        	temp[3] := -3333;
        if N4.Text<>'' then
        	val(N4.Text,temp[4],err)
        else
        	temp[4] := -4444;
        if N5.Text<>'' then
        	val(N5.Text,temp[5],err)
        else
        	temp[5] := -5555;

        if (temp[1]=temp[2]) then begin
       		ris := NUMDUP;
                N1.Color := clRed;
                N2.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                N1.Color := clAqua;
                N2.Color := clAqua;
 	end;
        if (temp[1]=temp[3]) then begin
       		ris := NUMDUP;
                N1.Color := clRed;
                N3.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                N1.Color := clAqua;
                N3.Color := clAqua;
        end;
        if  (temp[1]=temp[4]) then begin
        	ris := NUMDUP;
                N1.Color := clRed;
                N4.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                N1.Color := clAqua;
                N4.Color := clAqua;
	end;
        if   (temp[1]=temp[5]) then begin
        	ris := NUMDUP;
                N1.Color := clRed;
                N5.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                N1.Color := clAqua;
                N5.Color := clAqua;
        end;
        if (temp[2]=temp[3]) then begin
        	ris := NUMDUP;
                N2.Color := clRed;
                N3.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                N2.Color := clAqua;
                N3.Color := clAqua;
        end;
        if (temp[2]=temp[4]) then begin
        	ris := NUMDUP;
                N2.Color := clRed;
                N4.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                N2.Color := clAqua;
                N4.Color := clAqua;
        end;
        if (temp[2]=temp[5]) then begin
        	ris := NUMDUP;
                N2.Color := clRed;
                N5.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                N2.Color := clAqua;
                N5.Color := clAqua;
        end;
        if (temp[3]=temp[4]) then begin
        	ris := NUMDUP;
                N3.Color := clRed;
                N4.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                N3.Color := clAqua;
                N4.Color := clAqua;
        end;
        if (temp[3]=temp[5]) then begin
        	ris := NUMDUP;
                N3.Color := clRed;
                N5.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                N3.Color := clAqua;
                N5.Color := clAqua;
        end;
        if (temp[4]=temp[5]) then begin
        	ris := NUMDUP;
                N4.Color := clRed;
                N5.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                N4.Color := clAqua;
                N5.Color := clAqua;
        end;

	{ Controlla che i minuti non superino 59 }
        if TM1.Text<>'' then
        	val(TM1.Text,temp[1],err)
        else
        	temp[1]:= 0;
        if TM2.Text<>'' then
        	val(TM2.Text,temp[2],err)
        else
        	temp[2] := 0;
        if TM3.Text<>'' then
                val(TM3.Text,temp[3],err)
        else
        	temp[3] := 0;
        if TM4.Text<>'' then
        	val(TM4.Text,temp[4],err)
        else
        	temp[4] := 0;
        if TM5.Text<>'' then
        	val(TM5.Text,temp[5],err)
        else
        	temp[5] := 0;

        if (temp[1]>59) then begin
        	ris := MING59;
                TM1.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                TM1.Color := clYellow;
        end;
        if (temp[2]>59) then begin
        	ris := MING59;
                TM2.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                TM2.Color := clYellow;
        end;
        if (temp[3]>59) then begin
        	ris := MING59;
                TM3.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                TM3.Color := clYellow;
        end;
        if (temp[4]>59) then begin
        	ris := MING59;
                TM4.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                TM4.Color := clYellow;
        end;
        if (temp[5]>59) then begin
        	ris := MING59;
                TM5.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                TM5.Color := clYellow;
        end;

	{ Controlla che i secondi non superino 59 }
        if TM1.Text<>'' then
        	val(TS1.Text,temp[1],err)
        else
        	temp[1]:= 0;
        if TM2.Text<>'' then
        	val(TS2.Text,temp[2],err)
        else
        	temp[2] := 0;
        if TM3.Text<>'' then
                val(TS3.Text,temp[3],err)
        else
        	temp[3] := 0;
        if TM4.Text<>'' then
        	val(TS4.Text,temp[4],err)
        else
        	temp[4] := 0;
        if TM5.Text<>'' then
        	val(TS5.Text,temp[5],err)
        else
        	temp[5] := 0;

        if (temp[1]>59) then begin
        	ris := SECG59;
                TS1.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                TS1.Color := clYellow;
        end;
        if (temp[2]>59) then begin
        	ris := SECG59;
                TS2.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                TS2.Color := clYellow;
        end;
        if (temp[3]>59) then begin
        	ris := SECG59;
                TS3.Color := clRed;
		MostraErrore(ris);
                N1.SetFocus;
                TS3.Color := clYellow;
        end;
        if (temp[4]>59) then begin
        	ris := SECG59;
                TS4.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                TS4.Color := clYellow;
        end;
        if (temp[5]>59) then begin
        	ris := SECG59;
                TS5.Color := clRed;
                MostraErrore(ris);
                N1.SetFocus;
                TS5.Color := clYellow;
        end;

        {
          Decimi e centesimi non possono superare
          9 e 99 rispettivamente (uno oppure due
          caratteri numerici) quindi  inutile
          controllarli.
        }
	MsgOK := ris;
end;

procedure TMainForm.AggiornaNcar;

var s: string;
    n,nc: integer;

begin
	nc := 0;
        for n:=1 to 11 do nc := nc + length(Msg[n]);
        if nc>255 then NCAR.Color := clRED else NCAR.Color := clAqua;
        NCAR.Caption := IntToStr(nc);
end;

procedure TMainForm.CancellaFoglio;

begin
	N1.Clear;
        TM1.Clear;
        TS1.Clear;
        TD1.Clear;
        C1.Clear;

	N2.Clear;
        TM2.Clear;
        TS2.Clear;
        TD2.Clear;
        C2.Clear;

       	N3.Clear;
        TM3.Clear;
        TS3.Clear;
        TD3.Clear;
        C3.Clear;

	N4.Clear;
        TM4.Clear;
        TS4.Clear;
        TD4.Clear;
        C4.Clear;

	N5.Clear;
        TM5.Clear;
        TS5.Clear;
        TD5.Clear;
        C5.Clear;

        CL1.Clear;
        CL2.Clear;
end;


procedure TMainForm.NuovoFoglio;

begin
        CancellaFoglio;
        N1.SetFocus;
        nc := 0;
        if Stato=NORMALE then begin
	        Config.FGNum := Config.FGNum+1;
        	SalvaConfig;
	        NFG.Text := IntToStr(Config.FGNum);
        end else begin
                NPS.ReadOnly := TRUE;
                NFG.ReadOnly := TRUE;
                NPS.Text := IntToStr(Config.PSNum);
		NFG.Text := IntToStr(Config.FGNum);
        	Stato := NORMALE;
        end;
end;

procedure TMainForm.MakeCaption;

var s,s1:string;

begin
	if Config.Connesso then begin
        	if NominativoConnesso = Config.CallDirGara then
        		s:='Connesso a '+NominativoConnesso
                else
        		s:='Connesso a '+NominativoConnesso+'???';

        end else
        	s:='Non connesso';

	s1 := Config.CallStazione;
        if s1='' then
        	s1 := 'ATTENZIONE! NOMINATIVO NON DEFINITO!';

       	MainForm.Caption := VERSIONE+' - '
       		+Config.NomeRally+' - '
        	+'PS '+IntToStr(Config.PSNUM)
       	        +' ('+s1+') - '
               	+s;
end;


procedure TMainForm.Parse(Line: string);

var
	s1,s2: string;
        i: integer;
        sz: pChar;
        parsed: boolean;
begin
	parsed := FALSE;
	if Pos('*** CONNECTED',Line)<>0 then begin
               	Config.Connesso:=TRUE;
        	if pos(Config.CallDirGara,Line)<>0 then begin
                        NominativoConnesso:=Config.CallDirGara;
                end else begin
                	s1 := copy(Line,18,255);
                        i:=pos(' via',Line);
                        if i<>0 then delete(s1,i,255);
                        NominativoConnesso:=s1;
                        s2 := 'Connesso a '+s1+', non a '+Config.CallDirGara+'!'+NUL;
                        MostraMessaggio(
                                @S2[1],
                        	'Prego controllare...');
                end;
                parsed := TRUE;
        end;
	if Pos('*** DISCONNECTED',Line)<>0 then begin
        	Config.Connesso:=FALSE;
                NominativoConnesso:='';
                parsed := TRUE;
        end;
	if (Pos('OK -',Line)<>0)
	or (Pos('Benvenuto',Line)<>0)
        or (Pos('NO -',Line)<>0)
        or (Pos('Connesso alla',Line)=1) then begin
                sz:=StrAlloc(256);
                StrPCopy(sz,Line);
        	Application.MessageBox(
        		sz,
                	'Messaggio dal server',
                	MB_ICONINFORMATION+MB_OK);
                StrDispose(sz);
                parsed := TRUE;
        end;
        if not parsed then begin
        	if Pos('*** ',Line)=1 then begin
	                sz:=StrAlloc(256);
        	        StrPCopy(sz,Line);
        		Application.MessageBox(
        			sz,
	                	'Messaggio dal TNC',
        	        	MB_ICONINFORMATION+MB_OK);
                	StrDispose(sz);
                end;
                if (Config.Connesso) and (Line<>'') and (Pos('cmd:',Line)=0) then begin
	                sz:=StrAlloc(256);
        	        StrPCopy(sz,Line);
        		Application.MessageBox(
        			sz,
	                	'Messaggio dal server',
        	        	MB_ICONINFORMATION+MB_OK);
                	StrDispose(sz);
                end;
                parsed := TRUE;
        end;
        MakeCaption;
end;



{===============
 Gestione eventi
================}

procedure TMainForm.FormCreate(Sender: TObject);

var
	i: integer;
        fn: string;

begin
	nc := 0;
        Primo := TRUE;
        Stato := NORMALE;
	LeggiConfig;

        AggiornaNcar;

        NPS.Text := IntToStr(Config.PSNum);
        NFG.Text := IntToStr(Config.FGNum);
        NPS.ReadOnly := TRUE;
        NFG.ReadOnly := TRUE;

        Config.MsgDir := FormatDateTime('"RL"ddmmyy',Date);
        try
        	MkDir(Config.MsgDir);
        except end;

        case Config.SecDecCent of
        	SECONDI: begin
        		TD1.Enabled := FALSE;
                	TD1.Color := clGray;
        		TD2.Enabled := FALSE;
                	TD2.Color := clGray;
        		TD3.Enabled := FALSE;
                	TD3.Color := clGray;
        		TD4.Enabled := FALSE;
                	TD4.Color := clGray;
        		TD5.Enabled := FALSE;
                	TD5.Color := clGray;
                end;
                DECIMI: begin
        		TD1.Enabled := TRUE;
                	TD1.Color := clYellow;
                        TD1.EditMask := '9;0; ';
        		TD2.Enabled := TRUE;
                	TD2.Color := clYellow;
                        TD2.EditMask := '9;0; ';
        		TD3.Enabled := TRUE;
                	TD3.Color := clYellow;
                        TD3.EditMask := '9;0; ';
        		TD4.Enabled := TRUE;
                	TD4.Color := clYellow;
                        TD4.EditMask := '9;0; ';
        		TD5.Enabled := TRUE;
                	TD5.Color := clYellow;
                        TD5.EditMask := '9;0; ';
                 end;
                 CENTESIMI: begin
        		TD1.Enabled := TRUE;
                	TD1.Color := clYellow;
                        TD1.EditMask := '99;0; ';
        		TD2.Enabled := TRUE;
                	TD2.Color := clYellow;
                        TD2.EditMask := '99;0; ';
        		TD3.Enabled := TRUE;
                	TD3.Color := clYellow;
                        TD3.EditMask := '99;0; ';
        		TD4.Enabled := TRUE;
                	TD4.Color := clYellow;
                        TD4.EditMask := '99;0; ';
        		TD5.Enabled := TRUE;
                	TD5.Color := clYellow;
                        TD5.EditMask := '99;0; ';
                 end;
	end;

        if Config.LogToFile then begin
        	MostraLog1.Enabled := TRUE;
        	FmtStr(fn,'%s\RL%s.log',[Config.MsgDir,FormatDateTime('ddmmyy',Date)]);
       		AssignFile(LogF,fn);
                LogFileName := fn;
                try
                	append(LogF);
                except
                	rewrite(LogF);
                end;
		WriteLn(LogF,'**** '+VERSIONE+' lanciato il '+FormatDateTime('dd/mm/yyyy" alle "hh:mm:ss',Now));
                Flush(LogF);
	end else begin
                MostraLog1.Enabled := FALSE;
        end;
        {
	  Inizializzazioni per ridimensionamento componenti e font.

	  Copiato bovinamente da un esempio di Ari Hirviniemi.
	  I commenti sono quelli originali dell'Autore.

	  Save original window size and components size and positions for
	  later calculations. Warning: here's fixed array and it's supposed
	  that no component is created or deleted at run-time. There is
	  more elegant solutions but this is just for simplicity.
	}

	for i := 0 to ComponentCount - 1 do
        	if Components[i] is TControl then begin
	  		Xs[i] := TControl(Components[i]).Left;
			Ys[i] := TControl(Components[i]).Top;
	  		Ws[i] := TControl(Components[i]).Width;
	  		Hs[i] := TControl(Components[i]).Height;
        	end;
        {
	  Scale window so that it's size compared to screen size is same
	  as designed. Note that divisors here are your desing-time
	  screen dimensions.
        }
        OH := 420;
	OW := 628;
	Height := Screen.Height-1;
	Width := Screen.Width-1;

	MakeCaption;
end;


procedure TMainForm.MaskEditKeyPress(Sender: TObject; var Key: Char);

var
	ris: integer;
        s: string;

begin
	case (Sender as TMaskEdit).Taborder of
		{ Prima riga }
        	0: begin
                	if Key=CR then begin
                        	TM1.Setfocus;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                end;

        	1: begin
                	if Key=CR then begin
                        	TS1.Setfocus;
                                if TM1.Text<>'' then begin
	                                ris := StrToInt(TM1.Text);
        	                        if ris<10 then TM1.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then N1.Setfocus;
                end;

        	2: begin
                	if Key=CR then begin
                        	if Config.SecDecCent=SECONDI then
                                	C1.SetFocus
                                else
					TD1.Setfocus;
                                if TS1.Text<>'' then begin
	                                ris := StrToInt(TS1.Text);
        	                        if ris<10 then TS1.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then TM1.Setfocus;
                end;

        	3: begin
                	if Key=CR then begin
                        	C1.Setfocus;
                                if TD1.Text<>'' then begin
	                                ris := StrToInt('0'+TD1.Text);
        	                        if (Config.SecDecCent=CENTESIMI) and (ris<10) then TD1.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;

                	if Key=chr(27) then TS1.Setfocus;
                end;
               	4: begin
                	if Key=CR then begin
                        	N2.Setfocus;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then
                       		if Config.SecDecCent=SECONDI then
 					TS1.Setfocus
                                else
                                	TD1.SetFocus;
                end;

		{ Seconda riga }
        	5: begin
                	if Key=CR then begin
                        	TM2.Setfocus;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                        if key=chr(27) then C1.SetFocus;
                end;

        	6: begin
                	if Key=CR then begin
                        	TS2.Setfocus;
                                if TM2.Text<>'' then begin
	                                ris := StrToInt(TM2.Text);
        	                        if ris<10 then TM2.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then N2.Setfocus;
                end;

        	7: begin
                	if Key=CR then begin
                       		if Config.SecDecCent=SECONDI then
                                	C2.SetFocus
                                else
                        		TD2.Setfocus;
                                if TS2.Text<>'' then begin
	                                ris := StrToInt('0'+TS2.Text);
        	                        if ris<10 then TS2.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then TM2.Setfocus;
                end;

        	8: begin
                	if Key=CR then begin
                        	C2.Setfocus;
                                if TD2.Text<>'' then begin
	                                ris := StrToInt('0'+TD2.Text);
        	                        if (Config.SecDecCent=CENTESIMI) and (ris<10) then TD2.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then TS2.Setfocus;
                end;
               	9: begin
                	if Key=CR then begin
                        	N3.Setfocus;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then
                    		if Config.SecDecCent=SECONDI then
                                	TS2.SetFocus
                                else
					TD2.Setfocus;
                end;

		{ Terza riga }
        	10: begin
                	if Key=CR then begin
                        	TM3.Setfocus;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                        if key=chr(27) then C2.SetFocus;
                end;

        	11: begin
                	if Key=CR then begin
                        	TS3.Setfocus;
                                if TM3.Text<>'' then begin
	                                ris := StrToInt(TM3.Text);
        	                        if ris<10 then TM3.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then N3.Setfocus;
                end;

        	12: begin
                	if Key=CR then begin
                       		if Config.SecDecCent=SECONDI then
					C3.SetFocus
                                else
                        		TD3.Setfocus;
                                if TS3.Text<>'' then begin
	                                ris := StrToInt('0'+TS3.Text);
        	                        if ris<10 then TS3.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then TM3.Setfocus;
                end;

        	13: begin
                	if Key=CR then begin
                        	C3.Setfocus;
                                if TD3.Text<>'' then begin
	                                ris := StrToInt('0'+TD3.Text);
        	                        if (Config.SecDecCent=CENTESIMI) and (ris<10) then TD3.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then TS3.Setfocus;
                end;
               	14: begin
                	if Key=CR then begin
                        	N4.Setfocus;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then
                       		if Config.SecDecCent=SECONDI then
                                	TS3.SetFocus
                                else
 					TD3.Setfocus;
                end;

		{ Quarta riga }
        	15: begin
                	if Key=CR then begin
                        	TM4.Setfocus;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                        if key=chr(27) then C3.SetFocus;
                end;

        	16: begin
                	if Key=CR then begin
                        	TS4.Setfocus;
                                if TM4.Text<>'' then begin
	                                ris := StrToInt(TM4.Text);
        	                        if ris<10 then TM4.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then N4.Setfocus;
                end;

        	17: begin
                	if Key=CR then begin
                       		if Config.SecDecCent=SECONDI then
                                	C4.SetFocus
                                else
                        		TD4.Setfocus;
                                if TS4.Text<>'' then begin
	                                ris := StrToInt('0'+TS4.Text);
        	                        if ris<10 then TS4.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then TM4.Setfocus;
                end;

        	18: begin
                	if Key=CR then begin
                        	C4.Setfocus;
                                if TD4.Text<>'' then begin
	                                ris := StrToInt('0'+TD4.Text);
        	                        if (Config.SecDecCent=CENTESIMI) and (ris<10) then TD4.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then TS4.Setfocus;
                end;
               	19: begin
                	if Key=CR then begin
                        	N5.Setfocus;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then
                       		if Config.SecDecCent=SECONDI then
                                	TS4.SetFocus
                                else
                        		TD4.Setfocus;
                end;

		{ Quinta riga }
        	20: begin
                	if Key=CR then begin
                        	TM5.Setfocus;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                        if key=chr(27) then C4.SetFocus;
                end;

        	21: begin
                	if Key=CR then begin
                        	TS5.Setfocus;
                                if TM5.Text<>'' then begin
	                                ris := StrToInt(TM5.Text);
        	                        if ris<10 then TM5.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then N5.Setfocus;
                end;

        	22: begin
                	if Key=CR then begin
                       		if Config.SecDecCent=SECONDI then
                                	C5.SetFocus
                                else
                        		TD5.Setfocus;
                                if TS5.Text<>'' then begin
	                                ris := StrToInt('0'+TS5.Text);
        	                        if ris<10 then TS5.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then TM5.Setfocus;
                end;

        	23: begin
                	if Key=CR then begin
                        	C5.Setfocus;
                                if TD5.Text<>'' then begin
	                                ris := StrToInt('0'+TD5.Text);
        	                        if (Config.SecDecCent=CENTESIMI) and (ris<10) then TD5.Text:='0'+IntToStr(ris);
                                end;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then TS5.Setfocus;
                end;
               	24: begin
                	if Key=CR then begin
                        	CL1.Setfocus;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                	if Key=chr(27) then
                       		if Config.SecDecCent=SECONDI then
                                	TS5.SetFocus
                                else
                         		TD5.Setfocus;
                end;

		{ Sesta riga }
        	25: begin
                	if Key=CR then begin
                        	CL2.Setfocus;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                        if key=chr(27) then C5.SetFocus;
                end;

       		{ Settima riga }
        	26: begin
                	if (Key=CR) then begin
                        	SalvaTX.Setfocus;
                                CompilaMsg;
                                AggiornaNcar;
                        end;
                        if key=chr(27) then CL1.SetFocus;
                end;

        end;
end;


procedure TMainForm.SalvaTXKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
        if primo then begin
        	primo := FALSE;
        end else begin
               if Key=VK_RETURN then begin
        		SalvaTX.Click;
                	N1.Setfocus;
                	primo := TRUE;
               end;
        end;
end;



procedure TMainForm.SalvaTXClick(Sender: TObject);

var n,ris: integer;

begin
	if MsgOK = NOERROR then begin
		{ Messaggio OK, Salva e trasmette }
                SalvaMsg;
                TrasmettiMsg;
        	NuovoFoglio;
        	InizializzaMsg;
        	AggiornaNcar;
        end;
end;

procedure TMainForm.SalvaClick(Sender: TObject);
begin
	if MsgOK = NOERROR then begin
		SalvaMsg;
        	NuovoFoglio;
                InizializzaMsg;
                AggiornaNCar;
        end;

end;


procedure TMainForm.TXClick(Sender: TObject);
begin
	if MsgOK = NOERROR then begin
	        CompilaMSG;
        	TrasmettiMSG;
                NuovoFoglio;
                InizializzaMsg;
                AggiornaNcar;
        end;
end;


procedure TMainForm.AnnullaClick(Sender: TObject);
begin
	{ Cancella tutto e riparte da capo }
        CancellaFoglio;
        InizializzaMsg;
        AggiornaNCar;
        N1.SetFocus;
	if Stato=EDITING then begin
        	NPS.Text := IntToStr(Config.PSNum);
	        NFG.Text := IntToStr(Config.FGNum);
                NPS.ReadOnly := TRUE;
                NFG.ReadOnly := TRUE;
       		Stato := NORMALE;
        end;
end;


procedure TMainForm.Visualizza1Click(Sender: TObject);
begin
	Term.Show;
        ScriviTerminale('');
        Term.Terminale.Lines.Delete(Term.Terminale.Lines.Count-1);
end;


procedure TMainForm.Nascondi1Click(Sender: TObject);
begin
	Term.Hide;
end;


procedure TMainForm.Esci1Click(Sender: TObject);
begin
	if Application.MessageBox('Vuoi veramente uscire?',
        	'Uscita dal programma',
                MB_OKCancel) = IDOK then begin
                if Config.LogToFile then begin
			WriteLn(LogF,'**** '+VERSIONE+' terminato il '+FormatDateTime('dd/mm/yyyy" alle "hh:mm:ss',Now));
                	CloseFile(LogF);
                end;
                if Config.Connesso then begin
			DisconnettiDirezioneGara1.Click;
                end;
                Halt;
        end;
end;


procedure TMainForm.Informazionisu2Click(Sender: TObject);
begin
	AboutBox.Show;
end;


procedure TMainForm.FormResize(Sender: TObject);

var i: integer;
    c: TControl;
    s,s1: string;

begin
  { Create font that size is relative to window size and delete
	old font. }
  hNewFont := CreateFont(ClientHeight div 12, ClientWidth div 50, 0, 0,
			  FW_BOLD, 0, 0, 0, 1, OUT_DEVICE_PRECIS, 0,
			  PROOF_QUALITY, FF_DONTCARE, 'Arial Black');
  if hNewFont <> 0 then begin
	  hOldFont := MainForm.Font.Handle;
	  MainForm.Font.Handle := hNewFont;
	  DeleteObject(hOldFont);
  end;

  { Here's actual component scaling. }
  for i := 0 to ComponentCount - 1 do begin
	if Components[i] is TControl then begin
	  c := TControl(Components[i]);
	  c.Left   := Xs[i] * Longint(ClientWidth) div OW;
	  c.Top	   := Ys[i] * Longint(ClientHeight) div OH;
	  c.Width  := Ws[i] * Longint(ClientWidth) div OW;
	  c.Height := Hs[i] * Longint(ClientHeight) div OH;
	end;
  end;
  { Finally save window dimensions }
  PrevWidth  := ClientWidth;
  PrevHeight := ClientHeight;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
	Ora.Caption := FormatDateTime('hh:nn:ss',Time);
end;

procedure TMainForm.GNUPublicLicense1Click(Sender: TObject);
begin
	FGNU.Show;
end;

procedure TMainForm.Caricafoglio1Click(Sender: TObject);

var f: TextFile;
    l,s: string;
    i: integer;

begin
	OpenDialog1.InitialDir := Config.MsgDir;
        OpenDialog1.Filename := '';
	if OpenDialog1.Execute then begin
        	Stato:=EDITING;
                NPS.ReadOnly := FALSE;
                NFG.ReadOnly := FALSE;
        	CancellaFoglio;
                AssignFile(f,OpenDialog1.Filename);
        	Reset(f);

                ReadLn(f,l);
                if l<>'$T' then begin
                	MostraMessaggio(
                        	'Foglio senza $T iniziale?!',
                                'Qualcosa non va...');
                        Exit;
                end;

                ReadLn(f,l);
		i := Pos(' ',l);
               	Delete(l,1,i);
		i := Pos(' ',l);
               	NPS.Text := Copy(l,1,i-1);
               	Delete(l,1,i);
		i := Pos(' ',l);
               	Delete(l,1,i);
               	NFG.Text := Copy(l,1,length(l));

                ReadLn(f,l);
		i := Pos(' ',l);
               	N1.Text := Copy(l,1,i-1);
               	Delete(l,1,i);

		i := Pos(' ',l);
               	TM1.Text := Copy(l,1,i-1);
               	Delete(l,1,i);

                if Config.SecDecCent<>SECONDI then begin
			i := Pos(' ',l);
        	       	TS1.Text := Copy(l,1,i-1);
               		Delete(l,1,i);

			i := Pos(' ',l);
                	if i <> 0 then begin
               			TD1.Text := Copy(l,1,i-1);
               			Delete(l,1,i);
                                C1.Text := Copy(l,1,length(l));
                	end else begin
               			TD1.Text := Copy(l,1,length(l));
                	end;
                end else begin
			i := Pos(' ',l);
                	if i <> 0 then begin
				TS1.Text := Copy(l,1,i-1);
               			Delete(l,1,i);
                                C1.Text := Copy(l,1,length(l));
                        end else begin
                                TS1.Text := Copy(l,1,length(l));
                        end;
                end;

                ReadLn(f,l);
		i := Pos(' ',l);
               	N2.Text := Copy(l,1,i-1);
               	Delete(l,1,i);

		i := Pos(' ',l);
               	TM2.Text := Copy(l,1,i-1);
               	Delete(l,1,i);

                if Config.SecDecCent<>SECONDI then begin
			i := Pos(' ',l);
        	       	TS2.Text := Copy(l,1,i-1);
               		Delete(l,1,i);

			i := Pos(' ',l);
                	if i <> 0 then begin
               			TD2.Text := Copy(l,1,i-1);
               			Delete(l,1,i);
                                C2.Text := Copy(l,1,length(l));
                	end else begin
               			TD2.Text := Copy(l,1,length(l));
                	end;
                end else begin
			i := Pos(' ',l);
                	if i <> 0 then begin
				TS2.Text := Copy(l,1,i-1);
               			Delete(l,1,i);
                                C2.Text := Copy(l,1,length(l));
                        end else begin
                                TS2.Text := Copy(l,1,length(l));
                        end;
                end;

                ReadLn(f,l);
		i := Pos(' ',l);
               	N3.Text := Copy(l,1,i-1);
               	Delete(l,1,i);

		i := Pos(' ',l);
               	TM3.Text := Copy(l,1,i-1);
               	Delete(l,1,i);

                if Config.SecDecCent<>SECONDI then begin
			i := Pos(' ',l);
        	       	TS3.Text := Copy(l,1,i-1);
               		Delete(l,1,i);

			i := Pos(' ',l);
                	if i <> 0 then begin
               			TD3.Text := Copy(l,1,i-1);
               			Delete(l,1,i);
                                C3.Text := Copy(l,1,length(l));
                	end else begin
               			TD3.Text := Copy(l,1,length(l));
                	end;
                end else begin
			i := Pos(' ',l);
                	if i <> 0 then begin
				TS3.Text := Copy(l,1,i-1);
               			Delete(l,1,i);
                                C3.Text := Copy(l,1,length(l));
                        end else begin
                                TS3.Text := Copy(l,1,length(l));
                        end;
                end;

                ReadLn(f,l);
		i := Pos(' ',l);
               	N4.Text := Copy(l,1,i-1);
               	Delete(l,1,i);

		i := Pos(' ',l);
               	TM4.Text := Copy(l,1,i-1);
               	Delete(l,1,i);

                if Config.SecDecCent<>SECONDI then begin
			i := Pos(' ',l);
        	       	TS4.Text := Copy(l,1,i-1);
               		Delete(l,1,i);

			i := Pos(' ',l);
                	if i <> 0 then begin
               			TD4.Text := Copy(l,1,i-1);
               			Delete(l,1,i);
                                C4.Text := Copy(l,1,length(l));
                	end else begin
               			TD4.Text := Copy(l,1,length(l));
                	end;
                end else begin
			i := Pos(' ',l);
                	if i <> 0 then begin
				TS4.Text := Copy(l,1,i-1);
               			Delete(l,1,i);
                                C4.Text := Copy(l,1,length(l));
                        end else begin
                                TS4.Text := Copy(l,1,length(l));
                        end;
                end;

                ReadLn(f,l);
		i := Pos(' ',l);
               	N5.Text := Copy(l,1,i-1);
               	Delete(l,1,i);

		i := Pos(' ',l);
               	TM5.Text := Copy(l,1,i-1);
               	Delete(l,1,i);

                if Config.SecDecCent<>SECONDI then begin
			i := Pos(' ',l);
        	       	TS5.Text := Copy(l,1,i-1);
               		Delete(l,1,i);

			i := Pos(' ',l);
                	if i <> 0 then begin
               			TD5.Text := Copy(l,1,i-1);
               			Delete(l,1,i);
                                C5.Text := Copy(l,1,length(l));
                	end else begin
               			TD5.Text := Copy(l,1,length(l));
                	end;
                end else begin
			i := Pos(' ',l);
                	if i <> 0 then begin
				TS5.Text := Copy(l,1,i-1);
               			Delete(l,1,i);
                                C5.Text := Copy(l,1,length(l));
                        end else begin
                                TS5.Text := Copy(l,1,length(l));
                        end;
                end;

                ReadLn(f,l);
                if l<>CTRLA then begin
                	if l='$N' then ReadLn(f,l);
                	CL1.Text := l;
                	ReadLn(f,l);
                	if l<>CTRLA then CL2.Text := l;
                end;
                CompilaMSG;
                AggiornaNCAR;
        end;

end;

procedure TMainForm.Ritrasmettifoglio1Click(Sender: TObject);

var
	f: TextFile;
        n: integer;
begin
	OpenDialog1.InitialDir := Config.MsgDir;
        OpenDialog1.Filename := '';
	if OpenDialog1.Execute then begin
                AssignFile(f,OpenDialog1.Filename);
        	Reset(f);
    		InizializzaMsg;
                n:=1;
                while not Eof(f) do begin
                	ReadLn(f,Msg[n]);
                        AppendStr(Msg[n],CR);
                        n := n+1;
                end;
                TrasmettiMsg;
        end;
end;

procedure TMainForm.Programma1Click(Sender: TObject);
begin
	ConfPrg.Show;
end;

procedure TMainForm.Portaseriale1Click(Sender: TObject);
begin
	ConfSer.Show;
end;


procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	if Application.MessageBox('Vuoi veramente uscire?',
        	'Uscita dal programma',
                MB_OKCancel) = IDOK then begin
                if Config.LogToFile then begin
			WriteLn(LogF,'**** '+VERSIONE+' terminato il '+FormatDateTime('dd/mm/yyyy" alle "hh:mm:ss',Now));
                	CloseFile(LogF);
                end;
                if Config.Connesso then begin
			DisconnettiDirezioneGara1.Click;
                end;
                Halt;
        end;
        Action := caNONE;
end;

procedure TMainForm.RS232ReceiveData(Sender: TObject; DataPtr: Pointer;
  DataSize: Integer);

var
	i: integer;
	p: ^char;
        tmp: string;

begin
	Timeout.Enabled:=FALSE;
        p := DataPtr;
	for i := 1 to DataSize do begin
        	case p^ of
                	LF,NUL:; { non far nulla }
			CR: begin
                        	tmp := Line;
                        	Line := '';
				ScriviTerminale(tmp);
                        	ScriviLog(tmp,TRUE);
                        	Parse(tmp);
                	    end;
                        else begin
				Line := Line + p^;
                        end;
                end;
		inc(p);
        end;
        Timeout.Enabled := TRUE;
end;

procedure TMainForm.TimeoutTimer(Sender: TObject);

var tmp: string;

begin
	if Line<>'' then begin
        	Timeout.Enabled := FALSE;
                tmp := Line;
        	Line:='';
        	ScriviTerminale(tmp);
		ScriviLog(tmp,TRUE);
                Parse(tmp);
        	Timeout.Enabled := TRUE;
        end;
end;

procedure TMainForm.ConnettiDirezioneGara1Click(Sender: TObject);

var
	s: string;
        err: boolean;

begin
	err := FALSE;
	if Config.CallStazione='' then begin
        	MostraMessaggio('Call stazione non definito','Attenzione!');
                err:=TRUE;
        end;
	if Config.CallDirGara='' then begin
        	MostraMessaggio('Call Direzione Gara non definito','Attenzione!');
                err:=TRUE;;
        end;
	if Config.Connesso then begin
        	MostraMessaggio('Sei gi connesso, prima sconnetti','Attenzione!');
                err:=TRUE;;
        end;
        if not err then begin
        	s := CTRLC+CR;
	        if RS232.SendString(s) then begin
                	ScriviTerminale(s);
                        ScriviLog(s, FALSE);
                end;
		s := 'C '+Config.CallDirGara;
       		if Config.Digi1<>'' then s:=s+' v '+Config.Digi1;
	        if Config.Digi2<>'' then s:=s+' '+Config.Digi2;
		s := s+CR;
	        if RS232.SendString(s) then begin
                	ScriviTerminale(s);
                        ScriviLog(s, FALSE);
                end;
        end;
end;

procedure TMainForm.DisconnettiDirezioneGara1Click(Sender: TObject);

var s: string;

begin
	s := CTRLC+CR;
        if RS232.SendString(s) then ScriviTerminale(s);
	s := 'D'+CR;
        if RS232.SendString(s) then ScriviTerminale(s);
end;

procedure TMainForm.InizializzaTNC1Click(Sender: TObject);
begin
        if not Config.Connesso then
		InizializzaTNC
        else
        	MostraMessaggio('Meglio di no, quando sei connesso', 'Attenzione');
end;


procedure TMainForm.Mostralog1Click(Sender: TObject);

var
	f: File of char;
        nb: longint;
        s: string;
        c: char;

begin
	FLogv.Caption := 'File di log (completo)';
	AssignFile(f, LogFileName);
        reset(f);
        nb := FileSize(f);
        if nb>32768 then begin
        	seek(f,nb-32768);
		FLogv.Caption := 'File di log (ultimi 32K)';
                nb := 32768;
	end;
        s:='';
	FlogV.Logv.Lines.Clear;
	while not eof(f) do begin
        	read(f,c);
                case c of
               		LF:;
                       	CR: begin
				FlogV.Logv.Lines.Add(s);
       	                        s := '';
               	        end;
                       	else s:=s+c;
                end;
        end;
        CloseFile(f);
	FlogV.Show;
	FlogV.Logv.Lines.Add('');
	FlogV.Logv.Lines.Delete(FlogV.Logv.Lines.Count-1);
end;


initialization
	{ Configurazione di default }
	with Config do begin
  		NomeRally := 'NOME RALLY NON DEFINITO';
	        MsgDir := '';
        	PSNum := 1;
	        FGNum := 1;
	        SecDecCent := DECIMI;
	        CallStazione := '';
	        CallDirGara := '';
                Digi1 := '';
                Digi2 := '';
	        Connesso := FALSE;
                LogToFile := TRUE;
	        ComPort := COM1 ;
	        ComBaud := B9600;
        	ComParity := PNONE;
	        ComStops := STOP1;
                ComBits := BIT8;
                ComHandshake := HHARDWARE;
                InizializzaTNC := TRUE;
        end;

end.
